﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace test
{
    class Program
    {
        private  string conn="Server=(local);Database=test;Uid=sa;Pwd=123456";
        private  DataTable ExecuteDatatable(string sql, List<SqlParameter> listParams)
        {
            SqlParameter[] paras = new SqlParameter[listParams.Count];
            for (int j = 0; j < listParams.Count; j++)
            {
                paras[j] = listParams[j];
            }
            if (conn == null || conn.Length == 0)
                throw new ArgumentNullException("conn");
            using (SqlConnection connection = new SqlConnection(conn))
            {
                connection.Open();
                if (connection == null)
                    throw new ArgumentNullException("connection");
                SqlCommand cmd = new SqlCommand();
                bool mustCloseConnection = false;
                if (cmd == null)
                    throw new ArgumentNullException("command");
                if (sql == null || sql.Length == 0)
                    throw new ArgumentNullException("sql");
                if (connection.State != ConnectionState.Open)
                {

                    mustCloseConnection = true;
                    connection.Open();
                }
                else
                {
                    mustCloseConnection = false;
                }
                cmd.Connection = connection;
                cmd.CommandText = sql;
                cmd.CommandType = CommandType.Text;
                if (paras != null)
                {
                    AttachParameters(cmd,paras);
                }
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataSet ds = new DataSet();
                    sda.Fill(ds);
                    cmd.Parameters.Clear();
                    if (mustCloseConnection)
                        connection.Close();
                    return ds.Tables[0];
                }

            }
        }
        private  void AttachParameters(SqlCommand command, SqlParameter[] commandParameters)
        {
            if (command == null) throw new ArgumentNullException("command");
            if (commandParameters != null)
            {
                foreach (SqlParameter p in commandParameters)
                {
                    if (p != null)
                    {
                        // 检查未分配值的输出参数,将其分配以DBNull.Value.
                        if ((p.Direction == ParameterDirection.InputOutput || p.Direction == ParameterDirection.Input) &&
                            (p.Value == null))
                        {
                            p.Value = DBNull.Value;
                        }
                        command.Parameters.Add(p);
                    }
                }
            }
        }
        private int Delete(string areaId)
        {
            string sql = @"SELECT areaId,parentId FROM Sys_areaInf where areaId=@areaId";
            List<SqlParameter> myList = new List<SqlParameter>();
            myList.Add(new SqlParameter("@areaId", areaId));
            DataTable dt1 = ExecuteDatatable(sql, myList);
            int count = 0;
            if (dt1.Rows.Count > 0)
            {
                count = Loop(dt1, 0);
            }
            return count;
        }
        private DataTable Select(string areaId)
        {
            string sql1 = @"SELECT areaId,parentId FROM Sys_areaInf WHERE parentId=@areaId";
            List<SqlParameter> myList1 = new List<SqlParameter>();
            myList1.Add(new SqlParameter("@areaId", areaId));
            return ExecuteDatatable(sql1, myList1);
        }
        private int Loop(DataTable dt, int i)
        {
            DataTable dt2;

            for (; i < dt.Rows.Count; i++)
            {
                dt2 = Select(dt.Rows[i]["areaId"].ToString());
                if (dt2.Rows.Count > 0)
                {
                    dt.Merge(dt2);
                    Loop(dt, ++i);
                }
            }
            return dt.Rows.Count;
        }
        static void Main(string[] args)
        {
            Program program = new Program();
            int count = program.Delete("1");
        }
    }
}
